package org.glassfish.domaincustomizer;

import com.sun.enterprise.config.serverbeans.Config;
import java.beans.PropertyVetoException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.glassfish.api.admin.config.DomainContext;
import org.glassfish.api.admin.config.DomainInitializer;
import org.glassfish.domaincustomizer.serverbeans.MyContainer;
import org.glassfish.domaincustomizer.serverbeans.MyElement;
import org.glassfish.domaincustomizer.serverbeans.MyElements;
import org.jvnet.hk2.annotations.Inject;
import org.jvnet.hk2.annotations.Scoped;
import org.jvnet.hk2.annotations.Service;
import org.jvnet.hk2.component.PerLookup;
import org.jvnet.hk2.config.ConfigSupport;
import org.jvnet.hk2.config.SingleConfigCode;
import org.jvnet.hk2.config.TransactionFailure;

/**
 *
 * @author romano
 */
@Service
@Scoped(PerLookup.class)
public final class MyDomainCustomizer implements DomainInitializer {

    @Inject(name="server-config")
    Config config;

    @Override
    public MyContainer getInitialConfig(DomainContext initialCtx) {
        MyContainer container = null;
        try {
            container = (MyContainer) ConfigSupport.apply(new SingleConfigCode<Config>() {
                public Object run(Config param) throws PropertyVetoException, TransactionFailure {
                    MyContainer c = param.createChild(MyContainer.class);
                    c.setName("container-example");
                    MyElements elts = param.createChild(MyElements.class);
                    MyElement e1 = elts.createChild(MyElement.class);
                    e1.setName("elt1");
                    MyElement e2 = elts.createChild(MyElement.class);
                    e2.setName("elt2");
                    elts.getMyElement().add(e1);
                    elts.getMyElement().add(e2);
                    c.setMyElements(elts);
                    return c;
                }
            }, config);
        } catch (TransactionFailure ex) {
            Logger.getLogger(MyDomainCustomizer.class.getName()).log(Level.SEVERE, null, ex);
        }
        return container;
    }
}